## shogun 0.9.3

=== Makefile ===
# Usage scenarios
#
# * To make a release (and tag it) run
#
#       make prepare-release
#       make svn-tag-release  
#       (cd releases/shogun_X.Y.Z ; make release ; make update-webpage)
#
# * To create a debian .orig.tar.gz run
#
#       make release DEBIAN=yes
#
# * To create a snapshot run
#
#       make release SNAPSHOT=yes
# 
# * To sign/md5sum the created tarballs and copy them to the webpage
#
#       make update-webpage
#
#
# The following additional options may be set
#
# DEBIAN=yes   						-> use debian naming scheme shogun_0.1.1+svn1337.orig.tar.gz
# SVMLIGHT=no						-> remove svm light
# COMPRESS=cruncher					-> use cruncher (bz2/gz etc as file compressor)
# SNAPSHOT=yes						-> use svn snapshot naming scheme
# MAINVERSION=0.2.0					-> main version
# EXTRAVERSION=+svn20061202			-> extra version string
# RELEASENAME=shogun-3.0.0+extra	-> use different releasename, here shogun-3.0.0+extra
#
# * For example to use gzip instead of bzip2 and to append an extra version
# string.
#       make release COMPRESS=gzip EXTRAVERSION=+svn20061202
#
# * To create a debian snapshot package
#
#      make DEBIAN=yes SNAPSHOT=yes
#

DEBIAN := no
SVMLIGHT := yes
COMPRESS := bzip2
MAINVERSION := $(shell awk '/Release/{print $$5;exit}' src/NEWS)
VERSIONBASE := $(shell echo $(MAINVERSION) | cut -f 1-2 -d '.')
EXTRAVERSION := 
RELEASENAME := shogun-$(MAINVERSION)$(EXTRAVERSION)
SVNVERSION := $(shell svn info 2>/dev/null | grep Revision: | cut -d ' ' -f 2)
LOGFILE := 'prepare-release.log'

stop:
	@echo
	@echo "To install shogun, please go to the 'src' directory,"
	@echo "most of the time"
	@echo
	@echo "cd src"
	@echo "./configure"
	@echo "make"
	@echo
	@echo "which will build all available interfaces of shogun"
	@echo "should be enough. For further information consult"
	@echo "especially the INSTALL and README files and try"
	@echo
	@echo "./configure --help"
	@echo

debian-package:	DEBIAN=yes
ifeq ($(DEBIAN),yes)
COMPRESS := gzip
SVMLIGHT := no
RELEASENAME := shogun_$(MAINVERSION)
ifeq ($(SNAPSHOT),yes)
RELEASENAME := $(RELEASENAME)+svn$(SVNVERSION)
endif
RELEASENAME := $(RELEASENAME).orig
else
ifeq ($(SNAPSHOT),yes)
RELEASENAME := $(RELEASENAME)+svn$(SVNVERSION)
endif
all: doc release matlab python octave
endif


.PHONY: all release package-from-release update-webpage svn-ignores clean distclean embed-main-version

DESTDIR := ../$(RELEASENAME)
REMOVE_SVMLIGHT := rm -f $(DESTDIR)/src/libshogun/classifier/svm/SVM_light.* $(DESTDIR)/src/libshogun/classifier/svm/Optimizer.* $(DESTDIR)/src/libshogun/regression/svr/SVR_light.* $(DESTDIR)/src/LICENSE.SVMlight; \
rm -f $(DESTDIR)/testsuite/data/classifier/SVMLight* $(DESTDIR)/testsuite/data/regression/SVRLight*	; \

=== doc/Makefile ===
.PHONY: doc clean distclean
EXAMPLE_FILES = $(shell find ../examples -name '*.py' -o -name '*.m' -o -name\
				'*.R' -type f | grep -v svn)
UNDOCUMENTED_EXAMPLE_DIRS = $(shell find ../examples/undocumented -type d | \
							grep -v svn)
DOCUMENTED_EXAMPLE_DIRS = $(patsubst ../examples/undocumented%,../examples/documented%,\
						  $(UNDOCUMENTED_EXAMPLE_DIRS))

doc: examples pages/Configure.generated
	doxygen Doxyfile

pages/Configure.generated:	../src/configure
	../src/configure --help 2>&1 >$@

doc_cn: examples_cn
	doxygen Doxyfile_cn

$(DOCUMENTED_EXAMPLE_DIRS): $(UNDOCUMENTED_EXAMPLES)
	$(MAKE) -C ../examples

examples: $(DOCUMENTED_EXAMPLE_DIRS) $(EXAMPLE_FILES)
	echo $(DOCUMENTED_EXAMPLE_DIRS)
	python ./insert_examples.py pages/

examples_cn: $(DOCUMENTED_EXAMPLE_DIRS) $(EXAMPLE_FILES)
	python ./insert_examples_cn.py pages_cn/

distclean: clean

clean: 
	rm -rf html html_cn
	rm -f pages/Configure.generated

=== examples/Makefile ===
.PHONY: examples

examples:
	bash ./generate_documented.sh

distclean: clean

clean: 
	(cd documented && rm -rf cmdline elwms libshogun matlab_and_octave \
		octave_modular python python_modular r r_modular )
	$(MAKE) -C undocumented/libshogun clean
	rm -f missing.log undocumented/*/*.txt

=== src/Makefile ===
ifneq (.config,$(wildcard .config))
all:
#runconfigurehunkstart
	@echo ==================
	@echo SHOGUN - Makefile
	@echo ==================
	@echo
	@echo
	@echo !!! Please run ./configure with the appropriate options first !!!
	@echo
	@echo For additional options see
	@echo "              ./configure --help"
	@echo
	@exit 1
#runconfigurehunkend
else
include .config
ifeq (.config-local,$(wildcard .config-local))
include .config-local
endif
PARTDEPS = $(foreach part, $(PARTS), $(part)/Makefile )
all:  $(PARTDEPS) examples
	@echo ============================================================
	@echo ==== Building shogun for platform $(KERNELNAME)-$(MACHINE)
	@echo ==== opts: $(COMPFLAGS_CPP)
	@echo ============================================================
	@echo 
	@+$(foreach part, $(PARTS), $(MAKE) -C $(part) $@ &&) true
	@echo 
	@echo ============================================================
	@echo ==== Done. Check the subdirectories for binaries.
	@echo ============================================================
	@echo 
endif

examples:
	$(MAKE) -C../examples
	touch $@

install:  $(PARTDEPS)
	+$(foreach part, $(PARTS), $(MAKE) -C $(part) install-$(part) &&) true

uninstall:
	@test -z "$(LIBDIR)" || rm -f "$(DESTDIR)$(LIBDIR)/libshogun"*
	@test -z "$(INCDIR)" || rm -rf "$(DESTDIR)$(INCDIR)/shogun"
	@test -z "$(BINDIR)" || rm -rf "$(DESTDIR)$(BINDIR)/shogun"
	@test -z "$(PYDIR)" || rm -rf "$(DESTDIR)$(PYDIR)/sg.so"
	@test -z "$(PYDIR)" || rm -rf "$(DESTDIR)$(PYDIR)/sg.dylib"
	@test -z "$(PYDIR)" || rm -rf "$(DESTDIR)$(PYDIR)/shogun"
	@test -z "$(RDIR)" || rm -rf "$(DESTDIR)$(RDIR)/shogun"
	@test -z "$(OCTDIR)" || rm -rf "$(DESTDIR)$(OCTDIR)/shogun"

tests:
	$(MAKE) check-examples
	$(MAKE) run-testsuite

run-testsuite: $(PARTDEPS)
	+$(foreach part, $(PARTS), $(MAKE) -C $(part) run-testsuite-$(part) &&) true

check-examples: $(PARTDEPS)
	+$(foreach part, $(PARTS), $(MAKE) -C $(part) check-examples-$(part) &&) true

doc:  $(PARTDEPS)
	+$(foreach part, $(PARTS), $(MAKE) -C $(part) doc-$(part) &&) true

distclean: clean
	@+$(foreach part, $(PARTS), $(MAKE) -C $(part) $@ &&) true
	@rm -f .config tags ui shogun libshogunui/shogun
	@rm -f */Makefile

clean:  $(PARTDEPS)
	@+$(foreach part, $(PARTS), $(MAKE) -C $(part) $@ &&) true
	@rm -f configure.log .cpuinfo ./configure-* cplex.log examples

dist:	distclean
	rm -f $(TAR).gz
	tar -cvf $(TAR) -C ../../ shogun/src && gzip -9 $(TAR)

$(PARTDEPS): Makefile.template
	@+$(foreach part, $(PARTS), cat Makefile.template | sed 's/template/$(part)/g' | \
		sed 's/TEMPLATE/$(shell echo $(part) | tr 'a-z' 'A-Z')/g' >$(part)/Makefile; )


ChangeLog:
	@if [ -n "`which svn2cl`" ]; then \
		svn2cl --group-by-day --authors=.authors 2>/dev/null; \
	else \
		echo "Need svn2cl (from subversion-tools) to update ChangeLog!"; \
		exit 1; \
	fi

=== examples/undocumented/libshogun/Makefile ===
LIB_PATH=/usr/lib
INC_PATH=/usr/include

INCLUDES=
LIBS=-lshogun -lblas

LINKFLAGS=
CXXFLAGS=-O3 -g

LIBRARY_PATH=LD_LIBRARY_PATH
LINKFLAGS+=$(LIBS) -L$(LIB_PATH) 
CXXFLAGS+=-I$(INC_PATH) $(INCLUDES)
CC=c++

TARGETS = basic_minimal classifier_libsvm classifier_minimal_svm \
		  classifier_mklmulticlass kernel_gaussian kernel_revlin \
		  library_dyn_int library_gc_array library_indirect_object \
		  library_hash

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

$(TARGETS): $(foreach t, $(TARGET), $t.cpp)

check-examples: $(TARGETS)
	@for t in $(TARGETS) ; do echo $$t && $(LIBRARY_PATH)="$(LIB_PATH):$$$(LIBRARY_PATH)" ./$$t >/dev/null; done

%: %.cpp
	$(CC) $(CXXFLAGS) $< $(LINKFLAGS) -o $@

=== debian/changelog ===
shogun (0.9.3-4ubuntu9) natty; urgency=low

  * Package still needs hard-coding of the python version.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Dec 2010 02:04:02 +0100

shogun (0.9.3-4ubuntu8) natty; urgency=low

  * Don't hard-code the python version in the control file. LP: #688721.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Dec 2010 01:10:06 +0100

shogun (0.9.3-4ubuntu6) natty; urgency=low

  * Don't depend on python-all-dev, but on python-dev only.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 10 Dec 2010 22:07:19 +0100

shogun (0.9.3-4ubuntu5) natty; urgency=low

  * Fix build failure with ld --as-needed.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Dec 2010 11:18:21 +0100

shogun (0.9.3-4ubuntu4) natty; urgency=low

  * Rebuild to add support for python 2.7.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Dec 2010 00:14:32 +0000

shogun (0.9.3-4ubuntu3) maverick; urgency=low

  * Build with -O1 on armel, timeouts on the buildds.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 29 Sep 2010 13:38:39 +0200

shogun (0.9.3-4ubuntu2) maverick; urgency=low

  * No change upload to build with new liblzma-dev.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 24 Sep 2010 18:59:37 +0200

shogun (0.9.3-4ubuntu1) maverick; urgency=low

  * Update from Debian Unstable to fix FTBFS. New Ubuntu changes:
    - Revert bump in python-numpy version requirements due to dh_numpy
    - Restore recommends on python-numpy due to lack of dh_numpy
    - Drop dh_numpy calls from debian/rules

 -- Scott Kitterman <scott@kitterman.com>  Wed, 25 Aug 2010 20:01:30 -0400

shogun (0.9.3-4) unstable; urgency=high

  * Workaround cdbs problem and hopefully only create doxygen doc once.
    - This should be a workaround for the FTBS caused by doxygen bugs.
    - Therefore increasing urgency to high.

 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 17 Aug 2010 21:16:30 +0200

shogun (0.9.3-3) unstable; urgency=low

  * Do not call make doc on arch-dep targets but on indep only avoiding
    doxygen doc builds more than once.
  * Convert package to pysupport and call dh_numpy manually upon install
    (Closes: #590731).

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 30 Jul 2010 21:16:49 +0200

shogun (0.9.3-2) unstable; urgency=low

  * Bump standards version to 3.9.1.0 (no changes required).
  * Use different logic to workaround FTBS with newer doxygen versions
  (Closes: #590422)
  * Add upstream patches to 
    - tolerate column vectors in hdf5 (hdf5_tolerate_column_vectors.patch)
    - fix a invalid free in ocas (ocas_free.patch)
    - add swig 2.0 support (swig2.0.patch)
    - wrap python files within the python-modular interface
      (swig_file_support.patch)
    - to add further safety checks for the linear kernel
      (linear_kernel_parameters.patch)
 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 27 Jul 2010 09:24:22 +0200

shogun (0.9.3-1) unstable; urgency=low

  * New upstream version with feature enhancements, cleanups and bugfixes.
    - soname change requires package renames to libshogun8 and libshogunui5.
    - Drop patches included upstream.

 -- Soeren Sonnenburg <sonne@debian.org>  Mon, 31 May 2010 15:43:45 +0200

shogun (0.9.2-1) unstable; urgency=low

  * New upstream version with feature enhancements, cleanups and bugfixes.
    - Switch to dpkg-source 3.0 (quilt) format.
    - Update copyright.
    - Drop patches included upstream.
    - Build depend on libhdf5-serial-dev to support hdf5 based i/o.
    - Apply patch from svn to fix libshogunui static file.

 -- Soeren Sonnenburg <sonne@debian.org>  Mon, 05 Apr 2010 15:33:33 +0200

shogun (0.9.1-2) unstable; urgency=low

  * Add support fro Renesas SH (thanks Nobuhiro Iwamatsu for the patch
  configure.diff): (Closes: #568825)
  * Workaround doxygen FTBS (patch doxygen.diff) (Closes: #568612)
  * Apply upstream patches to limit training time in libsvm and mc svm
  (patches libsvm_mc_time_limit.diff, libsvm_time_limit.diff)
  * Apply upstream patch to fix get_kernel_matrix etc for custom kernels
  (custom_kernel_init.diff)
  * Apply upstream patch improving error message (hmm_observations.diff)
  * Apply upstream patch correcting a wrong liblinear sign flip
  (sign_flip_liblinear.diff)
  * Bump standards version (no changes required).

 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 09 Feb 2010 09:27:18 +0100

shogun (0.9.1-1) unstable; urgency=low

  * New upstream version with feature enhancements, cleanups and bugfixes.
  * Drop configure patch to workaround FTBS (included upstream).
  * Build depend on liblzo2-dev, zlib1g-dev, liblzma-dev to support
  shoguns compressed files.
  * Add patch from upstream svn to fix get_w() and set_w() for linear
  classifiers.
  * Use publicly available svn url for debian sources (Closes: #556096).
  * Rename shogun-doc package to shogun-doc-en and build chinese documentation
  and include it in package shogun-doc-cn.
  * Update copyright.

 -- Soeren Sonnenburg <sonne@debian.org>  Thu, 19 Nov 2009 15:14:36 +0100

shogun (0.9.0-2) unstable; urgency=low

  * Add glpk to build depends to enable multiple kerel learning.
  * Include configure patch to workaround FTBS.

 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 27 Oct 2009 14:54:10 +0100

shogun (0.9.0-1) unstable; urgency=low

  * New upstream version with major feature enhancements, cleanups
  and documentation updates.
  * Build depend on libreadline-dev | libreadline5-dev.
  * Build depend on doxygen (>= 1.6.0).
  * Build depend on swig (>= 1.3.40).
  * Drop octave3.0 support and compile for octave3.2.
  * Update copyright.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 23 Oct 2009 18:40:05 +0200

shogun (0.8.0-2) unstable; urgency=low

  * Fix override disparity (put libs in section lib).
  * Fix linitian warning, shogun-dbg now depends on
  libshogun and libshogunui.
  * Build depend on libreadline-dev instead of libreadline5-dev.

 -- Soeren Sonnenburg <sonne@debian.org>  Sun, 13 Sep 2009 16:01:04 +0200

shogun (0.8.0-1) unstable; urgency=low



=== debian/control ===
Source: shogun
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Soeren Sonnenburg <sonne@debian.org>
Build-Depends: libatlas-base-dev [!powerpc !alpha !arm !armel !sh4] | liblapack-dev,
 debhelper (>= 5), libreadline-dev | libreadline5-dev, octave3.2-headers, python-dev,
 ghostscript, python-support (>= 1.0.0), python-numpy (>= 1:1.0.4-5~), cdbs,
 r-base-core (>= 2.6.1-2), libblas-dev, swig (>= 1.3.40), xutils-dev, doxygen (>= 1.6.0),
 graphviz, texlive-latex-base, libglpk-dev, liblzo2-dev, zlib1g-dev, liblzma-dev,
 libhdf5-serial-dev (>= 1.8.3)
XS-Python-Version: 2.7
Standards-Version: 3.9.1.0
Homepage: http://www.shogun-toolbox.org
Vcs-Svn: http://bollin.googlecode.com/svn/shogun/trunk/
Vcs-Browser: http://bollin.googlecode.com/svn/shogun/trunk/

Package: libshogun8
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the core
 library all interfaces are based on.

Package: libshogun-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun8 (= ${binary:Version})
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This package
 includes the developer files required to create stand-a-lone executables.

Package: libshogunui5
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun8 (= ${binary:Version})
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the
 interface library that all static interfaces use.

Package: libshogunui-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshogunui5 (= ${binary:Version}),
 libshogun-dev
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This package
 includes the developer files required to create stand-a-lone executables.

Package: shogun-doc-en
Conflicts: shogun-doc
Replaces: shogun-doc
Section: doc
Architecture: all
Recommends: shogun-python-modular, libshogun-dev
Depends: ${misc:Depends}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the English
 user and developer documentation.

Package: shogun-doc-cn
Section: doc
Architecture: all
Recommends: shogun-python-modular, libshogun-dev
Depends: ${misc:Depends}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This is the 
 Chinese user and developer documentation.

Package: shogun-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libshogun8 (= ${binary:Version}),
 libshogunui5 (= ${binary:Version})
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same
 domain, where  an optimal sub-kernel weighting can be learned using Multiple
 Kernel Learning.  Apart from SVM 2-class classification and regression
 problems, a number of linear methods like Linear Discriminant Analysis (LDA),
 Linear Programming Machine (LPM), (Kernel) Perceptrons and also algorithms to
 train hidden markov models are implemented. The input feature-objects can be
 dense, sparse or strings and of type int/short/double/char and can be
 converted into different feature types. Chains of preprocessors (e.g.
 substracting the mean) can be attached to each feature object allowing for
 on-the-fly pre-processing.
 .
 SHOGUN comes in different flavours, a stand-a-lone version and also with
 interfaces to Matlab(tm), R, Octave, Readline and Python. This package
 contains debug symbols for all interfaces.

Package: shogun-python-modular
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 libshogun8 (= ${binary:Version})
Recommends: python-numpy, python-matplotlib, python-scipy
Provides: ${python:Provides}
Description: Large Scale Machine Learning Toolbox
 SHOGUN - is a new machine learning toolbox with focus on large scale kernel
 methods and especially on Support Vector Machines (SVM) with focus to
 bioinformatics. It provides a generic SVM object interfacing to several
 different SVM implementations. Each of the SVMs can be combined with a variety
 of the many kernels implemented. It can deal with weighted linear combination
 of a number of sub-kernels, each of which not necessarily working on the same

=== debian/rules ===
#!/usr/bin/make -f

DEB_SHLIBDEPS_INCLUDE := $(shell octave-config -p OCTLIBDIR) /usr/lib/atlas $(CURDIR)/src/libshogun $(CURDIR)/src/libshogunui
DEB_COMPRESS_EXCLUDE  := .py .html .R .m .sg
DEB_PYTHON_SYSTEM=pysupport
DEB_CONFIGURE_EXTRA_FLAGS += --disable-cpudetection --prefix=/usr
R_LIBRARY_DIR         := /usr/lib/R/site-library
LIBSHOGUN := libshogun8
LIBSHOGUNUI := libshogunui5

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/octave/debian/defs.make

PYVER     = $(shell pyversions -vr debian/control)
PYSTEST    = $(MAKE) -C src/python tests \
			DESTDIR=$(CURDIR)/debian/shogun-python-modular;
PYMTEST    = $(MAKE) -C src/python_modular tests \
			DESTDIR=$(CURDIR)/debian/shogun-python-modular;
PYSINSTALL = $(MAKE) -C src/python install \
			DESTDIR=$(CURDIR)/debian/shogun-python;
PYMINSTALL = $(MAKE) -C src/python_modular install \
			DESTDIR=$(CURDIR)/debian/shogun-python-modular;

patch: apply-patches

# doc
configure:: debian/stamp-configure
debian/stamp-configure:
	cd src && ./configure --disable-cpudetection --prefix=/usr --python=python$(PYVER)\
		--enable-glpk --enable-readline --enable-hdf5 \
		--interfaces=libshogun,libshogunui,cmdline,r,octave,python,elwms,python_modular,octave_modular
	touch $@

build-arch: configure debian/stamp-build-arch
debian/stamp-build-arch:
	$(MAKE) -C src
	touch $@

install/shogun-doc-en:: debian/stamp-install-doc-en
debian/stamp-install-doc-en:
	$(MAKE) -C doc doc
	$(RM) doc/html/*.map
	$(RM) doc/html/*.md5
	$(RM) doc/html/installdox
	$(RM) doc/html/formula.repository
	mkdir -p $(CURDIR)/debian/shogun-doc-en/usr/share/doc/shogun-doc-en
	cp -r doc/html $(CURDIR)/debian/shogun-doc-en/usr/share/doc/shogun-doc-en/
	touch $@

install/shogun-doc-cn:: debian/stamp-install-doc-cn
debian/stamp-install-doc-cn:
	$(MAKE) -C doc doc_cn
	$(RM) doc/html_cn/*.map
	$(RM) doc/html_cn/*.md5
	$(RM) doc/html_cn/installdox
	$(RM) doc/html_cn/formula.repository
	mkdir -p $(CURDIR)/debian/shogun-doc-cn/usr/share/doc/shogun-doc-cn
	cp -r doc/html_cn $(CURDIR)/debian/shogun-doc-cn/usr/share/doc/shogun-doc-cn/html
	touch $@

#libshogun
install/$(LIBSHOGUN):: debian/stamp-install-$(LIBSHOGUN)
debian/stamp-install-$(LIBSHOGUN):
	mkdir -p $(CURDIR)/debian/$(LIBSHOGUN)
	$(MAKE) -C src/libshogun install \
		DESTDIR=$(CURDIR)/debian/$(LIBSHOGUN) 
	cp -p src/libshogun/*.so.* $(CURDIR)/debian/$(LIBSHOGUN)/usr/lib
	$(RM) -r $(CURDIR)/debian/$(LIBSHOGUN)/usr/include
	$(RM) $(CURDIR)/debian/$(LIBSHOGUN)/usr/lib/libshogun.so
	$(RM) $(CURDIR)/debian/$(LIBSHOGUN)/usr/lib/libshogun.a
	touch $@

#libshogun-dev
install/libshogun-dev:: debian/stamp-install-libshogun-dev
debian/stamp-install-libshogun-dev:
	mkdir -p $(CURDIR)/debian/libshogun-dev
	$(MAKE) -C src/libshogun install \
		DESTDIR=$(CURDIR)/debian/libshogun-dev
	$(RM) -r $(CURDIR)/debian/libshogun-dev/usr/include/shogun/ui
	$(RM) $(CURDIR)/debian/libshogun-dev/usr/lib/libshogun.so.*
	touch $@

#libshogunui
install/$(LIBSHOGUNUI):: debian/stamp-install-$(LIBSHOGUNUI)
debian/stamp-install-$(LIBSHOGUNUI):
	mkdir -p $(CURDIR)/debian/$(LIBSHOGUNUI)
	$(MAKE) -C src/libshogunui install \
		DESTDIR=$(CURDIR)/debian/$(LIBSHOGUNUI) 
	cp -p src/libshogunui/*.so.* $(CURDIR)/debian/$(LIBSHOGUNUI)/usr/lib
	$(RM) -r $(CURDIR)/debian/$(LIBSHOGUNUI)/usr/include
	$(RM) $(CURDIR)/debian/$(LIBSHOGUNUI)/usr/lib/libshogunui.so
	$(RM) $(CURDIR)/debian/$(LIBSHOGUNUI)/usr/lib/libshogunui.a
	touch $@

#libshogunui-dev
install/libshogunui-dev:: debian/stamp-install-libshogunui-dev
debian/stamp-install-libshogunui-dev:
	mkdir -p $(CURDIR)/debian/libshogunui-dev
	$(MAKE) -C src/libshogunui install \
		DESTDIR=$(CURDIR)/debian/libshogunui-dev
	$(RM) $(CURDIR)/debian/libshogunui-dev/usr/lib/libshogunui.so.*
	touch $@

#cmdline
install/shogun-cmdline:: debian/stamp-install-cmdline
debian/stamp-install-cmdline:
	mkdir -p $(CURDIR)/debian/shogun-cmdline
	$(MAKE) -C src/cmdline install \
		DESTDIR=$(CURDIR)/debian/shogun-cmdline 
	touch $@

#octave
install/shogun-octave:: debian/stamp-install-octave
debian/stamp-install-octave:
	dh_install -pshogun-octave src/octave/sg.oct $(OCTDIR)
	octave-depends
	#$(MAKE) -C build-octave tests DESTDIR=$(CURDIR)/debian/shogun-octave
	touch $@

# octave-modular
install/shogun-octave-modular:: debian/stamp-install-octave-modular
debian/stamp-install-octave-modular:
	$(MAKE) -C src/octave_modular install \
		DESTDIR=$(CURDIR)/debian/shogun-octave-modular 
	octave-depends
	#$(MAKE) -C build-octave-modular tests \
		DESTDIR=$(CURDIR)/debian/shogun-octave-modular
	touch $@

# python-modular
install/shogun-python-modular:: debian/stamp-install-python-modular
debian/stamp-install-python-modular: modular=-modular
debian/stamp-install-python-modular:
	set -x; $(foreach pyver, $(PYVER), $(PYMINSTALL))
	#set -x; $(foreach pyver, $(PYVER), $(PYTEST))
	dh_pysupport -pshogun-python-modular
	touch $@

# python
install/shogun-python:: debian/stamp-install-python
debian/stamp-install-python: modular=
debian/stamp-install-python:
	set -x; $(foreach pyver, $(PYVER), $(PYSINSTALL))
	#set -x; $(foreach pyver, $(PYVER), $(PYTEST))
	dh_pysupport -pshogun-python
	touch $@

# elwms
install/shogun-elwms:: debian/stamp-install-elwms
debian/stamp-install-elwms:
	$(MAKE) DESTDIR=$(CURDIR)/debian/shogun-elwms RDIR=/usr/lib/R/site-library -C src/elwms install 
	dh_pysupport -pshogun-elwms
	octave-depends
	touch $@

# r
install/shogun-r:: debian/stamp-install-r
debian/stamp-install-r:
	$(MAKE) -C src/r install \
			DESTDIR=$(CURDIR)/debian/shogun-r \
			RDIR=/usr/lib/R/site-library
	#$(MAKE) -C src/r tests \
			DESTDIR=$(CURDIR)/debian/shogun-r \
			RDIR=/usr/lib/R/site-library;
	touch $@

get-orig-source:
	uscan --rename --force-download
	@echo successfully retrieved upstream tarball

clean::
	$(RM) debian/stamp-*
	$(RM) debian/shogun
	find debian -mindepth 2 -name 'shogun-*' -delete

## shogun 0.10.0

=== Makefile ===
--- 
+++ 
@@ -44,6 +44,9 @@
 MAINVERSION := $(shell awk '/Release/{print $$5;exit}' src/NEWS)
 VERSIONBASE := $(shell echo $(MAINVERSION) | cut -f 1-2 -d '.')
 EXTRAVERSION := 
+DATAMAINVERSION := $(shell awk '/Release/{print $$11;exit}' src/NEWS | tr -d '(,)' )
+DATAEXTRAVERSION :=
+DATARELEASENAME := shogun-data-$(DATAMAINVERSION)$(DATAEXTRAVERSION)
 RELEASENAME := shogun-$(MAINVERSION)$(EXTRAVERSION)
 SVNVERSION := $(shell svn info 2>/dev/null | grep Revision: | cut -d ' ' -f 2)
 LOGFILE := 'prepare-release.log'
@@ -83,6 +86,7 @@
 
 .PHONY: all release package-from-release update-webpage svn-ignores clean distclean embed-main-version
 
+DATADESTDIR := ../$(DATARELEASENAME)
 DESTDIR := ../$(RELEASENAME)
 REMOVE_SVMLIGHT := rm -f $(DESTDIR)/src/libshogun/classifier/svm/SVM_light.* $(DESTDIR)/src/libshogun/classifier/svm/Optimizer.* $(DESTDIR)/src/libshogun/regression/svr/SVR_light.* $(DESTDIR)/src/LICENSE.SVMlight; \
 rm -f $(DESTDIR)/testsuite/data/classifier/SVMLight* $(DESTDIR)/testsuite/data/regression/SVRLight*	; \

=== src/Makefile ===
--- 
+++ 
@@ -80,6 +80,15 @@
 	@+$(foreach part, $(PARTS), cat Makefile.template | sed 's/template/$(part)/g' | \
 		sed 's/TEMPLATE/$(shell echo $(part) | tr 'a-z' 'A-Z')/g' >$(part)/Makefile; )
 
+linecount:
+	@echo -n "C/C++ source code files (.cpp,.c):"
+	@cat `find ./ -type f -name '*.cpp' -o -name '*.c'`  | grep -vc '^ *$$'
+	@echo -n "C/C++ header files (.h):"
+	@cat `find ./ -type f -name '*.h'`  | grep -vc '^ *$$'
+	@echo -n "SWIG header files (.i):"
+	@cat `find ./modular -type f -name '*.i'`  | grep -vc '^ *$$'
+	@echo -n "Total:"
+	@(cat `find ./ -type f -name '*.cpp' -o -name '*.c' -o -name '*.h'`; cat `find ./modular -type f -o -name '*.i'`)  | grep -vc '^ *$$'
 
 ChangeLog:
 	@if [ -n "`which svn2cl`" ]; then \

=== applications/sailfish/Makefile ===
CXXFLAGS=-O9 -g -I./include
LINKFLAGS=-lshogun -lgfortran
TARGETS = sailfish

all: $(TARGETS)

clean:
	rm -f $(TARGETS)

$(TARGETS): $(foreach t, $(TARGET), $t.cpp)

%: %.cpp
	gcc $(CXXFLAGS) $< $(LINKFLAGS) -lshogun -o $@

=== debian/changelog ===
shogun (0.10.0-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Apply upstream patch to fix FTBFS with new gcc (closes: #625115).  Thanks,
    Sebastian Ramacher!

 -- Julien Cristau <jcristau@debian.org>  Fri, 24 Jun 2011 20:30:58 +0200

shogun (0.10.0-2) unstable; urgency=low

  * Upload to unstable.

 -- Soeren Sonnenburg <sonne@debian.org>  Mon, 14 Feb 2011 11:10:50 +0100

shogun (0.10.0-1) experimental; urgency=low

  * New upstream version with major feature enhancements.
    - Fix build with ld --as-needed thanks Matthias Klose
      for the patch. (Closes:  #606018)
    - Cherry pick patches from upstream svn-trunk to fix build failure.

 -- Soeren Sonnenburg <sonne@debian.org>  Wed, 12 Jan 2011 17:29:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,20 @@
 Source: shogun
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Soeren Sonnenburg <sonne@debian.org>
+Maintainer: Soeren Sonnenburg <sonne@debian.org>
 Build-Depends: libatlas-base-dev [!powerpc !alpha !arm !armel !sh4] | liblapack-dev,
- debhelper (>= 5), libreadline-dev | libreadline5-dev, octave3.2-headers, python-dev,
- ghostscript, python-support (>= 1.0.0), python-numpy (>= 1:1.0.4-5~), cdbs,
+ debhelper (>= 5), libreadline-dev | libreadline5-dev, octave3.2-headers, python-all-dev,
+ ghostscript, python-support (>= 1.0.0), python-numpy (>= 1:1.4.1-4~), cdbs,
  r-base-core (>= 2.6.1-2), libblas-dev, swig (>= 1.3.40), xutils-dev, doxygen (>= 1.6.0),
  graphviz, texlive-latex-base, libglpk-dev, liblzo2-dev, zlib1g-dev, liblzma-dev,
- libhdf5-serial-dev (>= 1.8.3)
-XS-Python-Version: 2.7
-Standards-Version: 3.9.1.0
+ libhdf5-serial-dev (>= 1.8.3), libxml2-dev, libhdf5-serial-dev (>= 1.8.0), libjson0-dev
+XS-Python-Version: 2.6
+Standards-Version: 3.9.1
 Homepage: http://www.shogun-toolbox.org
 Vcs-Svn: http://bollin.googlecode.com/svn/shogun/trunk/
 Vcs-Browser: http://bollin.googlecode.com/svn/shogun/trunk/
 
-Package: libshogun8
+Package: libshogun9
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -43,7 +42,7 @@
 Package: libshogun-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun8 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun9 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -65,10 +64,10 @@
  interfaces to Matlab(tm), R, Octave, Readline and Python. This package
  includes the developer files required to create stand-a-lone executables.
 
-Package: libshogunui5
+Package: libshogunui6
 Architecture: any
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun8 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun9 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -93,7 +92,7 @@
 Package: libshogunui-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogunui5 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogunui6 (= ${binary:Version}),
  libshogun-dev
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
@@ -174,8 +173,8 @@
 Section: debug
 Priority: extra
 Architecture: any
-Depends: ${misc:Depends}, libshogun8 (= ${binary:Version}),
- libshogunui5 (= ${binary:Version})
+Depends: ${misc:Depends}, libshogun9 (= ${binary:Version}),
+ libshogunui6 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -200,8 +199,8 @@
 Package: shogun-python-modular
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
- libshogun8 (= ${binary:Version})
-Recommends: python-numpy, python-matplotlib, python-scipy
+ libshogun9 (= ${binary:Version})
+Recommends: python-matplotlib, python-scipy
 Provides: ${python:Provides}
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,9 @@
 DEB_SHLIBDEPS_INCLUDE := $(shell octave-config -p OCTLIBDIR) /usr/lib/atlas $(CURDIR)/src/libshogun $(CURDIR)/src/libshogunui
 DEB_COMPRESS_EXCLUDE  := .py .html .R .m .sg
 DEB_PYTHON_SYSTEM=pysupport
-DEB_CONFIGURE_EXTRA_FLAGS += --disable-cpudetection --prefix=/usr
 R_LIBRARY_DIR         := /usr/lib/R/site-library
-LIBSHOGUN := libshogun8
-LIBSHOGUNUI := libshogunui5
+LIBSHOGUN := libshogun9
+LIBSHOGUNUI := libshogunui6
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/octave/debian/defs.make
@@ -21,13 +20,14 @@
 PYMINSTALL = $(MAKE) -C src/python_modular install \
 			DESTDIR=$(CURDIR)/debian/shogun-python-modular;
 
-patch: apply-patches
-
 # doc
 configure:: debian/stamp-configure
 debian/stamp-configure:
-	cd src && ./configure --disable-cpudetection --prefix=/usr --python=python$(PYVER)\
-		--enable-glpk --enable-readline --enable-hdf5 \
+	cd src && ./configure --disable-cpudetection --prefix=/usr \
+		--python=python$(PYVER)\
+		--enable-glpk --enable-readline --disable-svm-light \
+		--enable-hdf5 --enable-json --enable-xml \
+		--enable-lzo --enable-gzip --enable-bzip2 --enable-lzma \
 		--interfaces=libshogun,libshogunui,cmdline,r,octave,python,elwms,python_modular,octave_modular
 	touch $@
 
@@ -134,6 +134,7 @@
 	set -x; $(foreach pyver, $(PYVER), $(PYMINSTALL))
 	#set -x; $(foreach pyver, $(PYVER), $(PYTEST))
 	dh_pysupport -pshogun-python-modular
+	dh_numpy
 	touch $@
 
 # python
@@ -143,6 +144,7 @@
 	set -x; $(foreach pyver, $(PYVER), $(PYSINSTALL))
 	#set -x; $(foreach pyver, $(PYVER), $(PYTEST))
 	dh_pysupport -pshogun-python
+	dh_numpy
 	touch $@
 
 # elwms
@@ -150,6 +152,7 @@
 debian/stamp-install-elwms:
 	$(MAKE) DESTDIR=$(CURDIR)/debian/shogun-elwms RDIR=/usr/lib/R/site-library -C src/elwms install 
 	dh_pysupport -pshogun-elwms
+	dh_numpy
 	octave-depends
 	touch $@
 
@@ -165,7 +168,7 @@
 	touch $@
 
 get-orig-source:
-	uscan --rename --force-download
+	uscan --rename --force-download --pasv
 	@echo successfully retrieved upstream tarball
 
 clean::
